#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<bool> used;

void dfs(int pos, int v) {
    if (v == 0) return;

    used[pos] = true;

    for (int i = 0; i < g[pos].size(); i++) {
        if (used[g[pos][i]]) continue;
        dfs(g[pos][i], v - 1);
    }
}

void print() {
    int cnt = 0;
    for (int i = 0; i < used.size(); i++) {
        cnt += used[i];
    }
    cout << cnt << endl;
    for (int i = 0; i < used.size(); i++) {
        if (used[i]) cout << i + 1 << " ";
    }
    cout << endl;
}

void sol() {
    int n, m, k;
    cin >> n >> m >> k;
    used.assign(n, false);
    g.assign(n, {});
    vector<pair<int, int>> sec(k);
    for (int i = 0; i < m; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v1--; v2--;
        g[v1].emplace_back(v2);
        g[v2].emplace_back(v1);
    }
    for (auto &[pos, v] : sec) {
        cin >> pos >> v;
        pos--;
    }
    for (auto &[pos, v] : sec) {
        dfs(pos, v + 1);
    }
    print();
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        sol();
    }
}
